from fastapi import APIRouter
from api.api_v1.endpoints import user
from .endpoints import project
from .endpoints import folder
from .endpoints import space
from .endpoints import dashboard
from .endpoints import report
# from .endpoints import authority
from .endpoints import data_mana
from .endpoints import query
from .endpoints import xquery
from .endpoints import interview
from .endpoints import forms
from .endpoints import data_auth
from .endpoints import event_mana
from .endpoints import test
from .authz import authz
from .check_data import controller as check_data
from .user_label import controller as user_label

api_router = APIRouter()
api_router.include_router(test.router, tags=["test"], prefix='/test')

api_router.include_router(user.router, tags=["用户接口"], prefix='/user')
api_router.include_router(project.router, tags=["项目接口"], prefix='/project')
api_router.include_router(folder.router, tags=["文件夹接口"], prefix='/folder')
api_router.include_router(space.router, tags=["空间接口"], prefix='/space')
api_router.include_router(dashboard.router, tags=["看板接口"], prefix='/dashboard')
api_router.include_router(report.router, tags=["报表接口"], prefix='/report')

# api_router.include_router(authority.router, tags=["权限管理接口"], prefix='/authority')
api_router.include_router(data_auth.router, tags=["数据权限"], prefix='/data_auth')

api_router.include_router(data_mana.router, tags=["数据管理"], prefix='/data_mana')
api_router.include_router(event_mana.router, tags=["数据管理"], prefix='/data_mana')

api_router.include_router(query.router, tags=["ck"], prefix='/ck')
api_router.include_router(xquery.router, tags=["xck"], prefix='/ck')

api_router.include_router(authz.router, tags=["api接口管理"], prefix='/authz')
api_router.include_router(check_data.router, tags=["打点验证"], prefix='/check_data')
api_router.include_router(user_label.router, tags=["用户标签"], prefix='/user_label')

api_router.include_router(interview.router, tags=["面试数据管理"], prefix='/itr')
api_router.include_router(forms.router, tags=["hr报表模板管理"], prefix='/forms')

