from motor.motor_asyncio import AsyncIOMotorDatabase
import schemas
from crud.base import CRUDBase

__all__ = 'api_board',

from schemas import ProjectDB

from utils import get_uid
class CRUDProjectNumber(CRUDBase):
    # 获取所有数据
    async def all_api(self, db: AsyncIOMotorDatabase):
        return await self.find_many(db)

    # 修改数据
    async def update(self, db: AsyncIOMotorDatabase, data_in: schemas.Api_board,opinion):
        name = data_in.name
        api_name=data_in.api_name
        api_path=data_in.api_path
        if opinion == True:
            await self.update_one(db, {'name': name,'api_name':api_name}, {'$set': {'api_path': api_path}})
        else:
            await self.update_one(db, {'name': name, 'api_path': api_path}, {'$set': {'api_name':api_name}})
    # 插入数据
    async def insert(self, db: AsyncIOMotorDatabase, data_in: schemas.Api_board):
        await self.insert_one(db, data_in.dict())
    #删除数据
    async def del_api(self, db: AsyncIOMotorDatabase, data_in: schemas.Api_board):

        return await self.delete(db,data_in.dict())




api_board = CRUDProjectNumber('api_board')