from motor.motor_asyncio import AsyncIOMotorDatabase
import schemas
from crud.base import CRUDBase

__all__ = 'api_interview_modes',


class ApiInterviewModes(CRUDBase):

    # 获取hr所有分组
    async def get_interview_modes(self, db: AsyncIOMotorDatabase, data_in: schemas.FindModes):
        where = data_in.where
        where.update({'hr_uid': data_in.hr_uid})
        return await self.find_many(db, where, {'_id': 0})

    # 插入一条全新的分组
    async def insert_modes(self, db: AsyncIOMotorDatabase, data_in: schemas.InsertModes):
        return await self.insert_one(db, data_in.dict())

    # 更新一条分组信息
    async def update_modes(self, db: AsyncIOMotorDatabase, data_in: schemas.UpdateModes):
        return await self.update_one(db, {'mode_id': data_in.mode_id}, {'$set': data_in.update_data})

    # 更新一条信息
    async def update_one_interview(self, db: AsyncIOMotorDatabase, res):
        return await self.update_one(db, {'_id': res['_id']}, {
            '$set': res})


api_interview_modes = ApiInterviewModes('interview_modes')
