from motor.motor_asyncio import AsyncIOMotorDatabase
import schemas
from crud.base import CRUDBase

__all__ = 'api_interview_remark',


class ApiInterviewRemark(CRUDBase):

    # 获取简历所有备注
    async def get_interview_remarks(self, db: AsyncIOMotorDatabase, data_in: schemas.FindRemark):
        where = data_in.where
        where.update({'remark_uid': data_in.remark_uid})
        return await self.find_many(db, where, {'_id': 0})

    # 插入一条全新的备注
    async def insert_remark(self, db: AsyncIOMotorDatabase, data_in: schemas.BaseRemark):
        return await self.insert_one(db, data_in.dict())

    # 更新一条备注数据
    async def update_remark(self, db: AsyncIOMotorDatabase, data_in: schemas.UpdateRemark):
        return await self.update_one(db, {'remark_uid': data_in.remark_uid}, {'$set': data_in.update_data})

    # 更新一条数据
    async def update_one_interview(self, db: AsyncIOMotorDatabase, res):
        return await self.update_one(db, {'_id': res['_id']}, {
            '$set': res})


api_interview_remark = ApiInterviewRemark('interview_remark')
