from motor.motor_asyncio import AsyncIOMotorDatabase
import schemas
from crud.base import CRUDBase

__all__ = 'url_list',


class Url_list(CRUDBase):
    # 获取所有级别权限的所有路由和路由状体
    async def get_all(self, db: AsyncIOMotorDatabase):
        return await self.find_many(db)

    # 获取对应级别权限的所有路由和路由状体
    async def get_url(self, db: AsyncIOMotorDatabase, data_in: schemas.Url_list):
        return await self.find_many(db, {'name': data_in.name})

    # 插入单条对应级别权限的路由和状态
    async def insert_url(self, db: AsyncIOMotorDatabase, data_in: schemas.Url_list):
        return await self.insert_one(db, data_in.dict())

    async def insert_urls(self, db: AsyncIOMotorDatabase, data_in: schemas.Url_lists):
        return await self.insert_one(db, data_in.dict())

    # 更新单条对应级别权限的路由和状态
    async def update_url_url(self, db: AsyncIOMotorDatabase, res):
        return await self.update_one(db, {'_id':res['_id']}, {
            '$set': {'state':res['state']}})

    async def find_one_url(self, db: AsyncIOMotorDatabase, data_in: schemas.Datalist):
        return await self.find_one(db, {'auth_id': data_in.role_id, 'path_name': data_in.path_name})
    #修改权限用户名字
    async def edit_name(self, db: AsyncIOMotorDatabase, data_in: schemas.Editname):
        where = {'auth_id': data_in.role_id}
        up_data = {'$set': {'name':data_in.name}}

        return await self.update_many(db, where, up_data)
    #删除一个权限用户
    async def delete_name(self,db: AsyncIOMotorDatabase, data_in: schemas.Del_roles):

        return await self.delete(db,{'auth_id':data_in.role_id})

url_list = Url_list('url_list')