from motor.motor_asyncio import AsyncIOMotorDatabase
import schemas
from crud.base import CRUDBase

__all__ = 'user_url',


class User_url(CRUDBase):
    # 获取一个用户的权限信息
    async def get_quanxian(self, db: AsyncIOMotorDatabase, data_in: schemas.Url_quanxian):
        return await self.find_one(db, {'user_id': data_in.user_id})

    # 插入一条全新的用户权限信息
    async def insert_quanxian(self, db: AsyncIOMotorDatabase, data_in: schemas.Url_quanxian):
        return await self.insert_one(db, data_in.dict())

    # 更新一条用户权限信息
    async def updata_quanxian(self, db: AsyncIOMotorDatabase, data_in: schemas.Url_quanxian):
        return await self.update_one(db, {'user': data_in.user, 'user_id': data_in.user_id},
                                     {'$set': {'game': data_in.game,'quanxian_id':data_in.quanxian_id, 'quanxian': data_in.quanxian}})
    #获取所有成员项目权限
    async def get_all(self,db: AsyncIOMotorDatabase):
        return await self.find_many(db)




user_url = User_url('user_url')