from typing import Any, List, Union

from pydantic import BaseModel, Field

from schemas import DBBase
from typing import Optional


class ApiBase(BaseModel):
    path: str = None
    name: str = None
    desc: str = None


class AddApi(ApiBase):
    path: str
    name: str
    desc: str = None


class UpdateApi(BaseModel):
    path: str
    name: str


class AddApiDB(DBBase, AddApi):
    pass


class DelApi(BaseModel):
    ids: List[str] = Field(..., description='要删除的id')


class EditApi(BaseModel):
    id: str = Field(..., description='要编辑的id')
    name: str
    desc: str
