import uuid
from datetime import datetime
from enum import Enum
from typing import List

from pydantic import BaseModel

from schemas import DBBase


class FolderBase(BaseModel):
    name: str = None


# 解析请求json 创建项目
class FolderCreate(FolderBase):
    name: str
    project_id: str
    cat: str
    pid: str


class FolderDelete(DBBase):
    pass


class Category(str, Enum):
    project = 'kanban'
    space = 'space'


# --------------------------------------------------------------
# 数据库模型
class FolderDB(DBBase):
    name: str
    user_id: str
    project_id: str
    cat: Category
    pid: str
    members: List[str] = []
    create_date: datetime = datetime.now()
