from typing import Dict, List, Union, Any
from pydantic import BaseModel


# 面试数据包含字段样式
class InterviewModel(BaseModel):
    auth: int  # 可操作最低权限 权限控制0表示最高权限  数字越大权限越小
    state: str  # 反馈状态,面试安排数据的反馈
    name: str  # 被面试人名
    phone: int  # 被面试者手机号
    position: str  # 面试职位
    teacher_name: str  # 面试官名
    boss_name: str  # 面试负责人
    stage: int  # 当前面试阶段 1-5 表示初试,复式,终试,offer,入职   0表示离职 -1表示拒绝
    interview_type: str  # 当前阶段面试类型  视频面试, 现场面试
    interview_location: str  # 面试地点
    interview_time: str  # 面试时间


# 面试查询格式
class InterviewQuery(BaseModel):
    data_in: Any
    interview_query: dict = dict()  # 查询删选条件
    find_column: List[str] = None  # 显示列名
