from datetime import datetime
from typing import List, Union, Dict
from pydantic import BaseModel
from typing import Optional


class Interview(BaseModel):
    date: dict  # 要查询的条件
    pages: int = 1  # 分页的当前页
    time_type: str  # 要查询的时间范围类型
    # date包含如下参数,如选择全部的则传空字符串
    # job_name: str   # 应聘职位
    # hr_name: str  # 面试负责人
    # interview_name: str  # 面试官
    # interview_type: int  # 面试类型
    # interview_sign: int  # 面试签到
    # feedback: int  # 面试反馈
    # interview_round: int  # 面试轮次


class Timesinter(BaseModel):
    start_time: str  # 开始时间
    end_time: str  # 结束时间


class Post_uid(BaseModel):
    uid: str  # 面试者简历在CK中的唯一标识
    resume_affix_id: List[str]  # 附件id


class get_uid(BaseModel):
    uid: str  # 面试者简历在CK中的唯一标识


class Entry(BaseModel):
    uid: str  # 面试者简历在CK中的唯一标识
    interview_stage: int  # 修改入职状态
    job_id:str #招聘职位的id


class Email_str(BaseModel):
    name: str  # 求职者名字
    job: str  # 应聘的职位
    times: str  # 入职时间
    money: str  # 薪资
    hr_name: str  # hr联系人
    phone: str  # hr联系电话
    email: str  # hr邮箱


class send_str_mail(BaseModel):
    user_id: str  # 接收者的唯一id
    email: str  # 接收者的邮箱
    email_str: str  # 需要发送的文本内容


class user_id(BaseModel):
    user_id: List[str]  # 钉钉接收者的唯一id
    name: str  # 求职者姓名


