import time
from datetime import datetime

from pydantic import BaseModel


# 备注信息
class BaseRemark(BaseModel):
    remark_id: str = int(time.time())  # 备注的唯一id
    remark_from: str  # 编写备注的人
    comment: str  # 备注内容
    stage_num: int = 0  # 备注查看权限
    remark_time: datetime = datetime.now()  # 备注时间
    remark_uid: str  # 备注的简历uid
    remark_stage: int  # 备注时简历所处阶段


# 查询备注规则
class FindRemark(BaseModel):
    remark_uid: str  # 简历uid
    where: dict = {}  # 其他条件


# 更新备注
class UpdateRemark(BaseModel):
    remark_uid: str  # 简历uid
    update_data: dict  # 修改的数据
