import time
from datetime import datetime

from pydantic import BaseModel


class Job(BaseModel):
    job_id: str = None  # 职位的唯一id
    job_name: str  # 职位名称
    job_sector: str  # 职位部门
    job_nature: str  # 职位性质
    job_priority: str  # 职位优先级
    owner_name: str  # 渠道
    principal: str  # 负责人
    patronn: str  # 协助人
    start_time: datetime = datetime.now()  # 开始招聘时间
    end_time: datetime = None  # 结束招聘时间
    function_type: str  # 职能类型
    filtering_rules: bool  # 是否使用筛选规则
    hiring_needs: bool  # 是否关联招聘需求
    auto_repeater: bool  # 是否自动转发
    cacsi_count: int = None  # 面试满意度反馈次数
    state: bool = None  # 职位招聘状态
    job_num: int = None  # 招聘人数
    education: str  # 学历要求
    job_rank: str  # 职位级别
    work_exp: str  # 工作经验
    report_obj: str  # 汇报对象
    min_money: int  # 薪资范围min
    max_money: int  # 薪资范围max
    requirement: str  # 需求描述


class Jobs(BaseModel):
    job_id: str = None  # 职位的唯一id
    job_name: str = None  # 职位名称
    job_sector: str = None  # 职位部门
    job_nature: str = None  # 职位性质
    job_priority: str = None  # 职位优先级
    owner_name: str = None  # 渠道
    principal: str = None  # 负责人
    patronn: str = None  # 协助人
    start_time: datetime = None  # 开始招聘时间
    end_time: datetime = None  # 结束招聘时间
    function_type: str = None  # 职能类型
    filtering_rules: bool = None  # 是否使用筛选规则
    hiring_needs: bool = None  # 是否关联招聘需求
    auto_repeater: bool = None  # 是否自动转发
    cacsi_count: int = None  # 面试满意度反馈次数
    state: bool = None  # 职位招聘状态
    job_num: int = None  # 目标招聘人数
    now_job_num: int = None  # 实际招聘人数
    education: str = None  # 学历要求
    job_rank: str = None  # 职位级别
    work_exp: str = None  # 工作经验
    report_obj: str = None  # 汇报对象
    min_money: int = None  # 薪资范围min
    max_money: int = None  # 薪资范围max
    requirement: str = None  # 需求描述


class Ins_Job(BaseModel):
    job_id: str = str(int(time.time()))  # 职位的唯一id
    job_name: str  # 职位名称
    job_sector: str  # 职位部门
    job_nature: str  # 职位性质
    job_priority: str  # 职位优先级
    owner_name: str  # 渠道
    principal: str  # 负责人
    patronn: str  # 协助人
    start_time: datetime = datetime.now()  # 开始招聘时间
    function_type: str  # 职能类型
    filtering_rules: bool  # 是否使用筛选规则
    hiring_needs: bool  # 是否关联招聘需求
    auto_repeater: bool  # 是否自动转发
    cacsi_count: int = 0  # 面试满意度反馈次数
    state: bool = True  # 职位招聘状态
    job_num: int = None  # 目标招聘人数
    now_job_num: int = None  # 实际招聘人数
    education: str  # 学历要求
    job_rank: str  # 职位级别
    work_exp: str  # 工作经验
    report_obj: str  # 汇报对象
    min_money: int  # 薪资范围min
    max_money: int  # 薪资范围max
    requirement: str  # 需求描述



