import uuid
from datetime import datetime
from typing import List, Optional

from pydantic import BaseModel, Field

from schemas import DBBase


class ProjectBase(BaseModel):
    name: str = None


class MemberRole(BaseModel):
    username: str
    user_id: str
    role_name: str
    data_auth_id: str


class ProjectAddMember(BaseModel):
    members: List[MemberRole]
    project_id: str


class ProjectMember(BaseModel):
    members: List[str]
    project_id: str


class ProjectDetail(BaseModel):
    project_id: str


class ProjectClean(BaseModel):
    project_id: str

class Import_project(BaseModel):
    game: str
    games: str

class ProjectRename(BaseModel):
    project_id: str
    rename: str


class ProjectDelMember(BaseModel):
    project_id: str
    role: str
    username: str


# 解析请求json 创建项目
class ProjectCreate(ProjectBase):
    name: str = Field(..., title='项目名')
    game: str = Field(..., title='游戏代号')
    #qudao:str = Field(...,title='渠道')

# 查询某个项目看板
class ProjectKanban(DBBase):
    pass


# --------------------------------------------------------------
# 数据库模型
class ProjectDB(DBBase):
    name: str
    game: str
    user_id: str
    members: List[str] = []
    create_date: datetime = datetime.now()
