from typing import List

from pydantic import Field
from pydantic.main import BaseModel

from schemas import DBBase


class RoleBase(BaseModel):
    game: str = None
    name: str = None
    desc: str = None


class AddRole(BaseModel):
    game: str
    name: str
    desc: str


class AddRoleDB(DBBase, AddRole):
    pass


class DelRole(BaseModel):
    ids: List[str] = Field(..., description='要删除的id')


class EditRole(BaseModel):
    role_id: str = Field(..., description='要编辑的id')
    name: str = None
    desc: str = None


class OwnerList(BaseModel):
    owners: list
    account_name: str
